diff --git a/tests/dmevents.c b/tests/dmevents.c
index 540bf0d..395b16d 100644
--- a/tests/dmevents.c
+++ b/tests/dmevents.c
@@ -207,7 +207,7 @@ static int teardown(void **state)
 	return 0;
 }
 
-int WRAP_FUNC(open)(const char *pathname, int flags)
+int WRAP_OPEN(const char *pathname, int flags)
 {
 	assert_ptr_equal(pathname, "/dev/mapper/control");
 	assert_int_equal(flags, O_RDWR);
@@ -389,7 +389,7 @@ static void test_init_waiter_bad1(void **state)
 	struct test_data *datap = (struct test_data *)(*state);
 	if (datap == NULL)
 		skip();
-	wrap_will_return(WRAP_FUNC(open), -1);
+	wrap_will_return(WRAP_OPEN, -1);
 	assert_int_equal(init_dmevent_waiter(&datap->vecs), -1);
 	assert_ptr_equal(waiter, NULL);
 }
@@ -400,7 +400,7 @@ static void test_init_waiter_good0(void **state)
 	struct test_data *datap = (struct test_data *)(*state);
 	if (datap == NULL)
 		skip();
-	wrap_will_return(WRAP_FUNC(open), 2);
+	wrap_will_return(WRAP_OPEN, 2);
 	assert_int_equal(init_dmevent_waiter(&datap->vecs), 0);
 	assert_ptr_not_equal(waiter, NULL);
 }
diff --git a/tests/sysfs.c b/tests/sysfs.c
index fc256d8..c623d1b 100644
--- a/tests/sysfs.c
+++ b/tests/sysfs.c
@@ -29,7 +29,7 @@ char *__wrap_udev_device_get_syspath(struct udev_device *ud)
 	return val;
 }
 
-int WRAP_FUNC(open)(const char *pathname, int flags)
+int WRAP_OPEN(const char *pathname, int flags)
 {
 	int ret;
 
@@ -167,10 +167,10 @@ static void test_sagv_open_fail(void **state)
 
 	will_return(__wrap_udev_device_get_syspath, "/foo");
 	expect_condlog(4, "open '/foo/bar'");
-	expect_string(WRAP_FUNC(open), pathname, "/foo/bar");
-	expect_value(WRAP_FUNC(open), flags, O_RDONLY);
+	expect_string(WRAP_OPEN, pathname, "/foo/bar");
+	expect_value(WRAP_OPEN, flags, O_RDONLY);
 	errno = ENOENT;
-	wrap_will_return(WRAP_FUNC(open), -1);
+	wrap_will_return(WRAP_OPEN, -1);
 	expect_condlog(3, "__sysfs_attr_get_value: attribute '/foo/bar' cannot be opened");
 	assert_int_equal(sysfs_attr_get_value((void *)state, "bar",
 					      buf, sizeof(buf)), -ENOENT);
@@ -182,9 +182,9 @@ static void test_sagv_read_fail(void **state)
 
 	will_return(__wrap_udev_device_get_syspath, "/foo");
 	expect_condlog(4, "open '/foo/bar'");
-	expect_string(WRAP_FUNC(open), pathname, "/foo/bar");
-	expect_value(WRAP_FUNC(open), flags, O_RDONLY);
-	wrap_will_return(WRAP_FUNC(open), TEST_FD);
+	expect_string(WRAP_OPEN, pathname, "/foo/bar");
+	expect_value(WRAP_OPEN, flags, O_RDONLY);
+	wrap_will_return(WRAP_OPEN, TEST_FD);
 	expect_value(__wrap_read, fd, TEST_FD);
 	expect_value(__wrap_read, count, sizeof(buf));
 	errno = EISDIR;
@@ -197,9 +197,9 @@ static void test_sagv_read_fail(void **state)
 
 	will_return(__wrap_udev_device_get_syspath, "/foo");
 	expect_condlog(4, "open '/foo/baz'");
-	expect_string(WRAP_FUNC(open), pathname, "/foo/baz");
-	expect_value(WRAP_FUNC(open), flags, O_RDONLY);
-	wrap_will_return(WRAP_FUNC(open), TEST_FD);
+	expect_string(WRAP_OPEN, pathname, "/foo/baz");
+	expect_value(WRAP_OPEN, flags, O_RDONLY);
+	wrap_will_return(WRAP_OPEN, TEST_FD);
 	expect_value(__wrap_read, fd, TEST_FD);
 	expect_value(__wrap_read, count, sizeof(buf));
 	errno = EPERM;
@@ -223,9 +223,9 @@ static void _test_sagv_read(void **state, unsigned int bufsz)
 	memset(buf, '.', sizeof(buf));
 	will_return(__wrap_udev_device_get_syspath, "/foo");
 	expect_condlog(4, "open '/foo/bar'");
-	expect_string(WRAP_FUNC(open), pathname, "/foo/bar");
-	expect_value(WRAP_FUNC(open), flags, O_RDONLY);
-	wrap_will_return(WRAP_FUNC(open), TEST_FD);
+	expect_string(WRAP_OPEN, pathname, "/foo/bar");
+	expect_value(WRAP_OPEN, flags, O_RDONLY);
+	wrap_will_return(WRAP_OPEN, TEST_FD);
 	expect_value(__wrap_read, fd, TEST_FD);
 	expect_value(__wrap_read, count, bufsz);
 	will_return(__wrap_read, sizeof(input) - 1);
@@ -250,9 +250,9 @@ static void _test_sagv_read(void **state, unsigned int bufsz)
 	memset(buf, '.', sizeof(buf));
 	will_return(__wrap_udev_device_get_syspath, "/foo");
 	expect_condlog(4, "open '/foo/baz'");
-	expect_string(WRAP_FUNC(open), pathname, "/foo/baz");
-	expect_value(WRAP_FUNC(open), flags, O_RDONLY);
-	wrap_will_return(WRAP_FUNC(open), TEST_FD);
+	expect_string(WRAP_OPEN, pathname, "/foo/baz");
+	expect_value(WRAP_OPEN, flags, O_RDONLY);
+	wrap_will_return(WRAP_OPEN, TEST_FD);
 	expect_value(__wrap_read, fd, TEST_FD);
 	expect_value(__wrap_read, count, bufsz);
 	will_return(__wrap_read, sizeof(input) - 1);
@@ -301,9 +301,9 @@ static void _test_sagv_read_zeroes(void **state, unsigned int bufsz)
 	memset(buf, '.', sizeof(buf));
 	will_return(__wrap_udev_device_get_syspath, "/foo");
 	expect_condlog(4, "open '/foo/bar'");
-	expect_string(WRAP_FUNC(open), pathname, "/foo/bar");
-	expect_value(WRAP_FUNC(open), flags, O_RDONLY);
-	wrap_will_return(WRAP_FUNC(open), TEST_FD);
+	expect_string(WRAP_OPEN, pathname, "/foo/bar");
+	expect_value(WRAP_OPEN, flags, O_RDONLY);
+	wrap_will_return(WRAP_OPEN, TEST_FD);
 	expect_value(__wrap_read, fd, TEST_FD);
 	expect_value(__wrap_read, count, bufsz);
 	will_return(__wrap_read, sizeof(input) - 1);
@@ -386,10 +386,10 @@ static void test_sasv_open_fail(void **state)
 
 	will_return(__wrap_udev_device_get_syspath, "/foo");
 	expect_condlog(4, "open '/foo/bar'");
-	expect_string(WRAP_FUNC(open), pathname, "/foo/bar");
-	expect_value(WRAP_FUNC(open), flags, O_WRONLY);
+	expect_string(WRAP_OPEN, pathname, "/foo/bar");
+	expect_value(WRAP_OPEN, flags, O_WRONLY);
 	errno = EPERM;
-	wrap_will_return(WRAP_FUNC(open), -1);
+	wrap_will_return(WRAP_OPEN, -1);
 	expect_condlog(3, "sysfs_attr_set_value: attribute '/foo/bar' cannot be opened");
 	assert_int_equal(sysfs_attr_set_value((void *)state, "bar",
 					      buf, sizeof(buf)), -EPERM);
@@ -401,9 +401,9 @@ static void test_sasv_write_fail(void **state)
 
 	will_return(__wrap_udev_device_get_syspath, "/foo");
 	expect_condlog(4, "open '/foo/bar'");
-	expect_string(WRAP_FUNC(open), pathname, "/foo/bar");
-	expect_value(WRAP_FUNC(open), flags, O_WRONLY);
-	wrap_will_return(WRAP_FUNC(open), TEST_FD);
+	expect_string(WRAP_OPEN, pathname, "/foo/bar");
+	expect_value(WRAP_OPEN, flags, O_WRONLY);
+	wrap_will_return(WRAP_OPEN, TEST_FD);
 	expect_value(__wrap_write, fd, TEST_FD);
 	expect_value(__wrap_write, count, sizeof(buf));
 	errno = EISDIR;
@@ -422,9 +422,9 @@ static void _test_sasv_write(void **state, unsigned int n_written)
 	assert_in_range(n_written, 0, sizeof(buf));
 	will_return(__wrap_udev_device_get_syspath, "/foo");
 	expect_condlog(4, "open '/foo/bar'");
-	expect_string(WRAP_FUNC(open), pathname, "/foo/bar");
-	expect_value(WRAP_FUNC(open), flags, O_WRONLY);
-	wrap_will_return(WRAP_FUNC(open), TEST_FD);
+	expect_string(WRAP_OPEN, pathname, "/foo/bar");
+	expect_value(WRAP_OPEN, flags, O_WRONLY);
+	wrap_will_return(WRAP_OPEN, TEST_FD);
 	expect_value(__wrap_write, fd, TEST_FD);
 	expect_value(__wrap_write, count, sizeof(buf));
 	will_return(__wrap_write, n_written);
@@ -489,7 +489,7 @@ int main(void)
 {
 	int ret = 0;
 
-	init_test_verbosity(4);
+	init_test_verbosity(5);
 	ret += test_sysfs();
 	return ret;
 }
diff --git a/tests/test-lib.c b/tests/test-lib.c
index 665d438..cdb2780 100644
--- a/tests/test-lib.c
+++ b/tests/test-lib.c
@@ -40,17 +40,17 @@ const char default_wwid_1[] = "TEST-WWID-1";
  */
 
 
-int REAL_FUNC(open)(const char *path, int flags, int mode);
+int REAL_OPEN(const char *path, int flags, int mode);
 
 static const char _mocked_filename[] = "mocked_path";
 
-int WRAP_FUNC(open)(const char *path, int flags, int mode)
+int WRAP_OPEN(const char *path, int flags, int mode)
 {
 	condlog(4, "%s: %s", __func__, path);
 
 	if (!strcmp(path, _mocked_filename))
 		return 111;
-	return REAL_FUNC(open)(path, flags, mode);
+	return REAL_OPEN(path, flags, mode);
 }
 
 int __wrap_libmp_get_version(int which, unsigned int version[3])
diff --git a/tests/wrap64.h b/tests/wrap64.h
index 6b92751..b1dfa38 100644
--- a/tests/wrap64.h
+++ b/tests/wrap64.h
@@ -29,6 +29,20 @@
 #define WRAP_FUNC(x) CONCAT2(__wrap_, WRAP_NAME(x))
 #define REAL_FUNC(x) CONCAT2(__real_, WRAP_NAME(x))
 
+/*
+ * With clang, glibc 2.39, and _FILE_OFFSET_BITS==64,
+ * open() resolves to __open64_2().
+ */
+#if defined(__GLIBC__) && __GLIBC_PREREQ(2, 39) && \
+	defined(__clang__) && __clang__ == 1 && \
+	defined(__fortify_use_clang) && __fortify_use_clang == 1
+#define WRAP_OPEN_NAME __open64_2
+#else
+#define WRAP_OPEN_NAME WRAP_NAME(open)
+#endif
+#define WRAP_OPEN CONCAT2(__wrap_, WRAP_OPEN_NAME)
+#define REAL_OPEN CONCAT2(__real_, WRAP_OPEN_NAME)
+
 /*
  * fcntl() needs special treatment; fcntl64() has been introduced in 2.28.
  * https://savannah.gnu.org/forum/forum.php?forum_id=9205